>[!note] Initial commands
>- module load gcc/11.2.0 
>- gcc -O2 -fopenmp -lm -g -fno-omit-frame-pointer exe1.c -o exe1.out
>>- ./exe1.out 
>- srun --partition=cpar --cpus-per-task=2 ./exe1.out perf stat exe1.out
>sbatch --partition=cpar --cpus-per-task=4 run.sh


## Ex 1
### a) Tempos de execução

|           | 2PUs | 4PUs |
| --------- | ---- | ---- |
| critical  |   0.032681249   |  0.031749990    |
| atomic    |   0.032905756   |  0.031628442    |
| reduction |   0.056825000   |   0.032184014   |
## b)

