---
dg-publish: true
---
🌫 14 Setembro 2023 - #DAA 

>[!note]+ Definition: Machine Learning
>Machine learning refers to a system capable of the autonomous acquisition and integration of knowledge. This capacity to learn from experience, analytical observation, and other means, results in a system that can continuously self-improve and thereby offer increased efficiency and effectiveness.

>[!note]+ Tom Mitchell, Machine Learning (1997)
>The field of machine learning is concerned with the question of how to construct computer programs that automatically improve with experience.

## Conteúdo
1. Dados
	1. Dados, Informação e Conhecimento
	2. Dados Estruturados, Não Estruturados e Híbridos
2. Extração de Conhecimento de Dados
	1. Caracterização do processo de extração de conhecimento
	2. Experimentação de casos de estudo e aplicação prática
	3. Resolucação de casos de estudo e aplicação prática
3. Sistemas de Apendizagem
4. Aprendizagem automática
	1. Aprendizagem supervisionada
	2. Aprendizagem não-supervisionada
	3. Aprendizagem por reforço
	4. Redes Neuronais
	5. Conjunto de Modelos
	6. Computação Natural (evolucionária, inteligência de enxames)


## Team
- Vitor Alves: valves@di.uminho.pt
- César Analide: analide@di.uminho.pt
- Filipa Ferraz: D7266@di.uminho.pt
- Bruno Fernandes: bruno.fernandes@algoritmi.uminho.pt
- Dalila Durães: dad@di.uminho.pt

## Avaliação
- **40%** - Prova escrita
	- Prova: 14 de Dezembro
	- Recurso: 18 de Janeiro
- **60%** - Trabalho de grupo
	- 1ª fase: 23 de Novembro
	- fase final: 11 de Janeiro
	- avaliação pelos pares: 27 de Janeiro 2023

